/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.65 Revision 1.87
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.65 2010/02/17 23:32:24 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.87 2010/11/13 20:50:57 wired Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Ben de Groot <yngwin@gentoo.org>,
8# Markos Chandras <hwoarang@gentoo.org>, 8# Markos Chandras <hwoarang@gentoo.org>,
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 15inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 16
17MY_PV=${PV/_/-} 17MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then 18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 19 MY_P=qt-everywhere-opensource-src-${MY_PV}
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
22 IUSE="+exceptions"
21else 23else
22 MY_P=qt-x11-opensource-src-${MY_PV} 24 MY_P=qt-x11-opensource-src-${MY_PV}
23fi 25fi
24 26
25HOMEPAGE="http://qt.nokia.com/" 27HOMEPAGE="http://qt.nokia.com/"
67# @DESCRIPTION: 69# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH
69qt4-build_pkg_setup() { 71qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71 73
74 # Protect users by not allowing downgrades between releases
75 # Downgrading revisions within the same release should be allowed
76 if has_version '>'${CATEGORY}/${P}-r9999 ; then
77 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then
78 eerror "Sanity check to keep you from breaking your system:"
79 eerror " Downgrading Qt is completely unsupported and will break your system!"
80 die "aborting to save your system"
81 else
82 ewarn "Downgrading Qt is completely unsupported and will break your system!"
83 fi
84 fi
85
86 if [[ "${PN}" == "qt-webkit" ]]; then
87 eshopts_push -s extglob
88 if is-flagq '-g?(gdb)?([1-9])'; then
89 echo
90 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
91 ewarn "You may experience really long compilation times and/or increased memory usage."
92 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
93 ewarn "For more info check out bug #307861"
94 echo
95 fi
96 eshopts_pop
97 fi
72 98
73 PATH="${S}/bin${PATH:+:}${PATH}" 99 PATH="${S}/bin${PATH:+:}${PATH}"
74 if [[ ${CHOST} != *-darwin* ]]; then 100 if [[ ${CHOST} != *-darwin* ]]; then
75 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 101 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
76 else 102 else
77 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}" 103 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
78 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for 104 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
79 # platform detection. Note: needs to come before any directories to 105 # platform detection. Note: needs to come before any directories to
80 # avoid extract failure. 106 # avoid extract failure.
81 [[ ${CHOST} == *-apple-darwin* ]] && \ 107 [[ ${CHOST} == *-apple-darwin* ]] && \
82 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm ${QT4_EXTRACT_DIRECTORIES}" 108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}"
83 fi 110 fi
84 111
85 # Make sure ebuilds use the required EAPI 112 # Make sure ebuilds use the required EAPI
86 if [[ ${EAPI} != [23] ]]; then 113 if [[ ${EAPI} != [23] ]]; then
87 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using" 114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
90 die "qt4-build eclass requires EAPI=2 or EAPI=3" 117 die "qt4-build eclass requires EAPI=2 or EAPI=3"
91 fi 118 fi
92 119
93 if ! version_is_at_least 4.1 $(gcc-version); then 120 if ! version_is_at_least 4.1 $(gcc-version); then
94 ewarn "Using a GCC version lower than 4.1 is not supported!" 121 ewarn "Using a GCC version lower than 4.1 is not supported!"
95 echo
96 ebeep 3
97 fi 122 fi
98} 123}
99 124
100# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
101# @DESCRIPTION: 126# @DESCRIPTION:
117 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 142 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
118 ${QT4_EXTRACT_DIRECTORIES}; do 143 ${QT4_EXTRACT_DIRECTORIES}; do
119 targets+=" ${MY_P}/${target}" 144 targets+=" ${MY_P}/${target}"
120 done 145 done
121 146
122 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 147 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
123 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 148 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
124} 149}
125 150
126# @ECLASS-VARIABLE: PATCHES 151# @ECLASS-VARIABLE: PATCHES
127# @DESCRIPTION: 152# @DESCRIPTION:
128# In case you have patches to apply, specify them in PATCHES variable. Make sure 153# In case you have patches to apply, specify them in PATCHES variable. Make sure
137# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 162# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
138# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 163# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf.
139qt4-build_src_prepare() { 164qt4-build_src_prepare() {
140 setqtenv 165 setqtenv
141 cd "${S}" 166 cd "${S}"
167
168 # fix qt 4.7 regression that skips -fvisibility=hidden
169 if version_is_at_least "4.7.0_beta1"; then
170 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
171 -i config.tests/unix/fvisibility.test ||
172 die "visibility fixing sed failed"
173 fi
174 # fix libx11 dependency on non X packages
175 if version_is_at_least "4.7.0_beta2"; then
176 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
177 hasq ${PN} ${NOLIBX11PKG} && qt_nolibx11
178 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup
179 fi
142 180
143 if use aqua; then 181 if use aqua; then
144 # provide a proper macx-g++-64 182 # provide a proper macx-g++-64
145 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 183 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
146 184
157 195
158 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 196 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
159 # qmake bus errors with -O2 but -O3 works 197 # qmake bus errors with -O2 but -O3 works
160 replace-flags -O2 -O3 198 replace-flags -O2 -O3
161 fi 199 fi
162
163 # Bug 282984 && Bug 295530
164 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \
165 -i configure || die "sed qmake compilers failed"
166 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \
167 -i config.tests/unix/compile.test || die "sed test compilers failed"
168 200
169 # Bug 178652 201 # Bug 178652
170 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 202 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
171 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 203 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
172 append-flags -fno-gcse 204 append-flags -fno-gcse
185 if use ppc64; then 217 if use ppc64; then
186 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 218 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
187 append-flags -mminimal-toc 219 append-flags -mminimal-toc
188 fi 220 fi
189 221
222 # Bug 282984 && Bug 295530
223 sed -e "s:\(^SYSTEM_VARIABLES\):CC="$(tc-getCC)"\nCXX="$(tc-getCXX)"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \
224 -i configure || die "sed qmake compilers failed"
225 # bug 321335
226 if version_is_at_least 4.6; then
227 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \
228 xargs -0 \
229 sed -e "s:\(\$MAKE\):\1 CC="$(tc-getCC)" CXX="$(tc-getCXX)" LD="$(tc-getCXX)" LINK="$(tc-getCXX)":g" \
230 -i || die "sed test compilers failed"
231 fi
232
190 # Bug 172219 233 # Bug 172219
191 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
192 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
193 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
194 -e "s:X11R6/::" \ 234 sed -e "s:X11R6/::" \
195 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 235 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
196 236
197 if [[ ${CHOST} != *-darwin* ]]; then 237 if [[ ${CHOST} == *-darwin* ]]; then
198 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
199 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
200 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
201 -i mkspecs/common/g++.conf || die "sed mkspecs/common/g++.conf failed"
202 else
203 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 238 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
204 # crippled (by design) :/ 239 # crippled (by design) :/
205 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 240 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
206 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 241 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
207 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 242 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
247 # use GCC over SunStudio 282 # use GCC over SunStudio
248 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 283 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
249 # don't flirt with non-Prefix stuff, we're quite possessive 284 # don't flirt with non-Prefix stuff, we're quite possessive
250 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 285 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
251 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 286 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
287 # strip predefined CFLAGS from qmake ( bug #312689 )
288 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
252 289
253 base_src_prepare 290 base_src_prepare
254} 291}
255 292
256# @FUNCTION: qt4-build_src_configure 293# @FUNCTION: qt4-build_src_configure
294 # freetype2 include dir is non-standard, thus include it on configure 331 # freetype2 include dir is non-standard, thus include it on configure
295 # use -I from configure 332 # use -I from configure
296 myconf+=" $(pkg-config --cflags freetype2)" 333 myconf+=" $(pkg-config --cflags freetype2)"
297 fi 334 fi
298 335
336 # Disable SSE4.x, since auto-detection is currently broken
337 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623
338 if version_is_at_least 4.7.1; then
339 myconf+=" -no-sse4.1 -no-sse4.2"
340 fi
341
299 echo ./configure ${myconf} 342 echo ./configure ${myconf}
300 ./configure ${myconf} || die "./configure failed" 343 ./configure ${myconf} || die "./configure failed"
301 myconf="" 344 myconf=""
302} 345}
303 346
305# @DESCRIPTION: Actual compile phase 348# @DESCRIPTION: Actual compile phase
306qt4-build_src_compile() { 349qt4-build_src_compile() {
307 setqtenv 350 setqtenv
308 351
309 build_directories ${QT4_TARGET_DIRECTORIES} 352 build_directories ${QT4_TARGET_DIRECTORIES}
353}
354
355# @FUNCTION: qt4-build_src_test
356# @DESCRIPTION:
357# Runs tests only in target directories.
358qt4-build_src_test() {
359 for dir in ${QT4_TARGET_DIRECTORIES}; do
360 emake -j1 check -C ${dir}
361 done
310} 362}
311 363
312# @FUNCTION: fix_includes 364# @FUNCTION: fix_includes
313# @DESCRIPTION: 365# @DESCRIPTION:
314# For MacOSX we need to add some symlinks when frameworks are 366# For MacOSX we need to add some symlinks when frameworks are
343 setqtenv 395 setqtenv
344 install_directories ${QT4_TARGET_DIRECTORIES} 396 install_directories ${QT4_TARGET_DIRECTORIES}
345 install_qconfigs 397 install_qconfigs
346 fix_library_files 398 fix_library_files
347 fix_includes 399 fix_includes
400 # remove .la files since we are building only shared Qt libraries
401 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm
348} 402}
349 403
350# @FUNCTION: setqtenv 404# @FUNCTION: setqtenv
351setqtenv() { 405setqtenv() {
352 # Set up installation directories 406 # Set up installation directories
452 { 506 {
453 echo "${S}"/mkspecs/common/*.conf 507 echo "${S}"/mkspecs/common/*.conf
454 find "${S}" -name '*.pr[io]' 508 find "${S}" -name '*.pr[io]'
455 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 509 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
456 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 510 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
457 emake CC="@echo compiling \$< && $(tc-getCC)" \ 511 emake CC="$(tc-getCC)" \
458 CXX="@echo compiling \$< && $(tc-getCXX)" \ 512 CXX="$(tc-getCXX)" \
459 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 513 LINK="$(tc-getCXX)" || die "emake failed"
460 popd >/dev/null 514 popd >/dev/null
461 done 515 done
462} 516}
463 517
464# @FUNCTION: install_directories 518# @FUNCTION: install_directories
711 fi 765 fi
712 766
713 echo "${spec}" 767 echo "${spec}"
714} 768}
715 769
770# @FUNCTION: qt_assistant_cleanup
771# @RETURN: nothing
772# @DESCRIPTION:
773# Tries to clean up tools.pro for qt-assistant ebuilds
774# Meant to be called in src_prepare
775qt_assistant_cleanup() {
776 # different versions (and branches...) may need different handling,
777 # add a case if you need special handling
778 case "${MY_PV_EXTRA}" in
779 *kde-qt*)
780 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
781 -e "/mac/,/^embedded.*makeqpf$/d" \
782 -i tools/tools.pro || die "patching tools.pro failed"
783 ;;
784 *)
785 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
786 -e "/mac/,/^embedded.*makeqpf$/d" \
787 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
788 -i tools/tools.pro || die "patching tools.pro failed"
789 ;;
790 esac
791}
792
793# @FUNCTION: qt_nolibx11
794# @RETURN: nothing
795# @DESCRIPTION:
796# Ignore X11 tests for packages that don't need X libraries installed
797qt_nolibx11() {
798 einfo "removing X11 check to allow X-less compilation"
799 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
800 die "x11 check sed failed"
801}
802
716EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 803EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.65  
changed lines
  Added in v.1.87

  ViewVC Help
Powered by ViewVC 1.1.20